﻿using System;
using System.ComponentModel;
using CheckBox_IndeterminateState;
using CheckBox_IndeterminateState.iOS;
using CoreGraphics;
using Foundation;
using Syncfusion.XForms.Buttons;
using Syncfusion.XForms.iOS.Buttons;
using UIKit;
using Xamarin.Forms;
using Xamarin.Forms.Platform.iOS;

[assembly: ExportRenderer(typeof(MyCheckBox), typeof(CheckBoxRenderer))]


namespace CheckBox_IndeterminateState.iOS
{
    public class CheckBoxRenderer : SfCheckBoxRenderer
    {
        private double width = 0;

        public CheckBoxRenderer()
        {
        }

        protected override void OnElementChanged(ElementChangedEventArgs<SfCheckBox> e)
        {
            base.OnElementChanged(e);
           
            if(Control != null)
            {
                Control.LineBreakMode = UILineBreakMode.CharacterWrap;

            }
        }

        protected override void OnElementPropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            base.OnElementPropertyChanged(sender, e);

            if(e.PropertyName.Equals("ControlWidth"))
            {
                width = (sender as MyCheckBox).ControlWidth;
            }
        }

        public override CGSize SizeThatFits(CGSize size)
        {
            var sizeValue = base.SizeThatFits(size);
            var text = Control.TitleLabel.Text;
            if (!string.IsNullOrEmpty(text))
            {
                NSString nsstring = new NSString(text);
                UIStringAttributes attribs = new UIStringAttributes
                {
                    Font = Control.Font,
                    ParagraphStyle = new NSMutableParagraphStyle()
                    {
                        LineBreakMode = UILineBreakMode.CharacterWrap
                    }
                };

                CoreGraphics.CGRect textSize = nsstring.GetBoundingRect(new CGSize(width, double.MaxValue), NSStringDrawingOptions.UsesLineFragmentOrigin, attribs, null);
                float strikeHeight = (float)textSize.Height;

                return new CGSize(sizeValue.Width, strikeHeight);
            }

            return sizeValue;
        }
    }
}
